"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from redrover_api.api_client import ApiClient, Endpoint as _Endpoint
from redrover_api.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from redrover_api.model.absence_reason_balance_create_request import AbsenceReasonBalanceCreateRequest
from redrover_api.model.absence_reason_balance_response import AbsenceReasonBalanceResponse
from redrover_api.model.absence_reason_balance_update_request import AbsenceReasonBalanceUpdateRequest
from redrover_api.model.bad_request_result import BadRequestResult
from redrover_api.model.not_found_result import NotFoundResult
from redrover_api.model.ok_object_result import OkObjectResult
from redrover_api.model.problem_details import ProblemDetails


class AbsenceReasonBalanceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_absence_reason_balance_endpoint = _Endpoint(
            settings={
                'response_type': (AbsenceReasonBalanceResponse,),
                'auth': [
                    'basic'
                ],
                'endpoint_path': '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances',
                'operation_id': 'create_absence_reason_balance',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'org_id',
                    'employee_identifier',
                    'absence_reason_balance_create_request',
                ],
                'required': [
                    'org_id',
                    'employee_identifier',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'org_id':
                        (int,),
                    'employee_identifier':
                        (str,),
                    'absence_reason_balance_create_request':
                        (AbsenceReasonBalanceCreateRequest,),
                },
                'attribute_map': {
                    'org_id': 'orgId',
                    'employee_identifier': 'employeeIdentifier',
                },
                'location_map': {
                    'org_id': 'path',
                    'employee_identifier': 'path',
                    'absence_reason_balance_create_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_absence_reason_balance_endpoint = _Endpoint(
            settings={
                'response_type': (OkObjectResult,),
                'auth': [
                    'basic'
                ],
                'endpoint_path': '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances/{id}',
                'operation_id': 'delete_absence_reason_balance',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'org_id',
                    'employee_identifier',
                    'id',
                ],
                'required': [
                    'org_id',
                    'employee_identifier',
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'org_id':
                        (int,),
                    'employee_identifier':
                        (str,),
                    'id':
                        (int,),
                },
                'attribute_map': {
                    'org_id': 'orgId',
                    'employee_identifier': 'employeeIdentifier',
                    'id': 'id',
                },
                'location_map': {
                    'org_id': 'path',
                    'employee_identifier': 'path',
                    'id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_absence_reason_balance_endpoint = _Endpoint(
            settings={
                'response_type': (AbsenceReasonBalanceResponse,),
                'auth': [
                    'basic'
                ],
                'endpoint_path': '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances/{id}',
                'operation_id': 'get_absence_reason_balance',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'org_id',
                    'employee_identifier',
                    'id',
                ],
                'required': [
                    'org_id',
                    'employee_identifier',
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'org_id':
                        (int,),
                    'employee_identifier':
                        (str,),
                    'id':
                        (int,),
                },
                'attribute_map': {
                    'org_id': 'orgId',
                    'employee_identifier': 'employeeIdentifier',
                    'id': 'id',
                },
                'location_map': {
                    'org_id': 'path',
                    'employee_identifier': 'path',
                    'id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_absence_reason_balances_endpoint = _Endpoint(
            settings={
                'response_type': ([AbsenceReasonBalanceResponse],),
                'auth': [
                    'basic'
                ],
                'endpoint_path': '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances',
                'operation_id': 'get_absence_reason_balances',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'org_id',
                    'employee_identifier',
                    'school_year_id',
                ],
                'required': [
                    'org_id',
                    'employee_identifier',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'org_id':
                        (int,),
                    'employee_identifier':
                        (str,),
                    'school_year_id':
                        (int,),
                },
                'attribute_map': {
                    'org_id': 'orgId',
                    'employee_identifier': 'employeeIdentifier',
                    'school_year_id': 'schoolYearId',
                },
                'location_map': {
                    'org_id': 'path',
                    'employee_identifier': 'path',
                    'school_year_id': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.update_absence_reason_balance_endpoint = _Endpoint(
            settings={
                'response_type': (AbsenceReasonBalanceResponse,),
                'auth': [
                    'basic'
                ],
                'endpoint_path': '/api/v1/{orgId}/Employee/{employeeIdentifier}/absenceReasonBalances/{id}',
                'operation_id': 'update_absence_reason_balance',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'org_id',
                    'employee_identifier',
                    'id',
                    'absence_reason_balance_update_request',
                ],
                'required': [
                    'org_id',
                    'employee_identifier',
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'org_id':
                        (int,),
                    'employee_identifier':
                        (str,),
                    'id':
                        (int,),
                    'absence_reason_balance_update_request':
                        (AbsenceReasonBalanceUpdateRequest,),
                },
                'attribute_map': {
                    'org_id': 'orgId',
                    'employee_identifier': 'employeeIdentifier',
                    'id': 'id',
                },
                'location_map': {
                    'org_id': 'path',
                    'employee_identifier': 'path',
                    'id': 'path',
                    'absence_reason_balance_update_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def create_absence_reason_balance(
        self,
        org_id,
        employee_identifier,
        **kwargs
    ):
        """Create Absence Reason Balance  # noqa: E501

        Create new Absence Reason Balance for an Employee  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_absence_reason_balance(org_id, employee_identifier, async_req=True)
        >>> result = thread.get()

        Args:
            org_id (int): The Red Rover Id of the Organization
            employee_identifier (str): The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)

        Keyword Args:
            absence_reason_balance_create_request (AbsenceReasonBalanceCreateRequest): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            AbsenceReasonBalanceResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['org_id'] = \
            org_id
        kwargs['employee_identifier'] = \
            employee_identifier
        return self.create_absence_reason_balance_endpoint.call_with_http_info(**kwargs)

    def delete_absence_reason_balance(
        self,
        org_id,
        employee_identifier,
        id,
        **kwargs
    ):
        """Delete Absence Reason Balance  # noqa: E501

        Delete an Absence Reason Balance for an Employee by its Red Rover Id (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_absence_reason_balance(org_id, employee_identifier, id, async_req=True)
        >>> result = thread.get()

        Args:
            org_id (int): The Red Rover Id of the Organization
            employee_identifier (str): The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)
            id (int): The id of the AbsenceReasonBalance

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            OkObjectResult
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['org_id'] = \
            org_id
        kwargs['employee_identifier'] = \
            employee_identifier
        kwargs['id'] = \
            id
        return self.delete_absence_reason_balance_endpoint.call_with_http_info(**kwargs)

    def get_absence_reason_balance(
        self,
        org_id,
        employee_identifier,
        id,
        **kwargs
    ):
        """Get Absence Reason Balance  # noqa: E501

        Gets a specific Absence Reason Balance by its Red Rover Id  (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_absence_reason_balance(org_id, employee_identifier, id, async_req=True)
        >>> result = thread.get()

        Args:
            org_id (int): The Red Rover Id of the Organization
            employee_identifier (str): The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)
            id (int): The id of the AbsenceReasonBalance

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            AbsenceReasonBalanceResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['org_id'] = \
            org_id
        kwargs['employee_identifier'] = \
            employee_identifier
        kwargs['id'] = \
            id
        return self.get_absence_reason_balance_endpoint.call_with_http_info(**kwargs)

    def get_absence_reason_balances(
        self,
        org_id,
        employee_identifier,
        **kwargs
    ):
        """Get Absence Reason Balances  # noqa: E501

        Get Absence Reason Balance for an employee  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_absence_reason_balances(org_id, employee_identifier, async_req=True)
        >>> result = thread.get()

        Args:
            org_id (int): The Red Rover Id of the Organization
            employee_identifier (str): The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)

        Keyword Args:
            school_year_id (int): Filter by school year (optional). [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            [AbsenceReasonBalanceResponse]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['org_id'] = \
            org_id
        kwargs['employee_identifier'] = \
            employee_identifier
        return self.get_absence_reason_balances_endpoint.call_with_http_info(**kwargs)

    def update_absence_reason_balance(
        self,
        org_id,
        employee_identifier,
        id,
        **kwargs
    ):
        """Update Absence Reason Balance  # noqa: E501

        Update an Absence Reason Balance for an Employee by its Red Rover Id (numeric)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_absence_reason_balance(org_id, employee_identifier, id, async_req=True)
        >>> result = thread.get()

        Args:
            org_id (int): The Red Rover Id of the Organization
            employee_identifier (str): The identifier of the Employee. If this is an External Id, prepend the value with the pike character `|` (e.g. `|ABC123`)
            id (int): The id of the AbsenceReasonBalance

        Keyword Args:
            absence_reason_balance_update_request (AbsenceReasonBalanceUpdateRequest): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            AbsenceReasonBalanceResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['org_id'] = \
            org_id
        kwargs['employee_identifier'] = \
            employee_identifier
        kwargs['id'] = \
            id
        return self.update_absence_reason_balance_endpoint.call_with_http_info(**kwargs)

