"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from redrover_api.api_client import ApiClient, Endpoint as _Endpoint
from redrover_api.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from redrover_api.model.bad_request_result import BadRequestResult
from redrover_api.model.problem_details import ProblemDetails
from redrover_api.model.vacancy_detail_response import VacancyDetailResponse


class VacancyApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_vacancy_details_endpoint = _Endpoint(
            settings={
                'response_type': ([VacancyDetailResponse],),
                'auth': [
                    'basic'
                ],
                'endpoint_path': '/api/v1/{orgId}/Vacancy/vacancyDetails',
                'operation_id': 'get_vacancy_details',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'org_id',
                    'from_date',
                    'to_date',
                    'api_key',
                    'verified',
                    'filled',
                    'substitute_source_org_id',
                    'limit',
                    'offset',
                    'include_deleted',
                ],
                'required': [
                    'org_id',
                    'from_date',
                    'to_date',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'org_id':
                        (int,),
                    'from_date':
                        (datetime,),
                    'to_date':
                        (datetime,),
                    'api_key':
                        (str,),
                    'verified':
                        (bool,),
                    'filled':
                        (bool,),
                    'substitute_source_org_id':
                        (int,),
                    'limit':
                        (int,),
                    'offset':
                        (int,),
                    'include_deleted':
                        (bool,),
                },
                'attribute_map': {
                    'org_id': 'orgId',
                    'from_date': 'fromDate',
                    'to_date': 'toDate',
                    'api_key': 'apiKey',
                    'verified': 'verified',
                    'filled': 'filled',
                    'substitute_source_org_id': 'substituteSourceOrgId',
                    'limit': 'limit',
                    'offset': 'offset',
                    'include_deleted': 'includeDeleted',
                },
                'location_map': {
                    'org_id': 'path',
                    'from_date': 'query',
                    'to_date': 'query',
                    'api_key': 'header',
                    'verified': 'query',
                    'filled': 'query',
                    'substitute_source_org_id': 'query',
                    'limit': 'query',
                    'offset': 'query',
                    'include_deleted': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def get_vacancy_details(
        self,
        org_id,
        from_date,
        to_date,
        **kwargs
    ):
        """ Query Vacancy Details  # noqa: E501

        Query for Vacancy Details based on specified search criteria  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_vacancy_details(org_id, from_date, to_date, async_req=True)
        >>> result = thread.get()

        Args:
            org_id (int): The Red Rover Id of the Organization
            from_date (datetime): From date to filter Vacancies
            to_date (datetime): From date to filter Vacancies

        Keyword Args:
            api_key (str): [optional]
            verified (bool): If a Vacancy has been verified. [optional]
            filled (bool): If a Vacancy has been filled. [optional]
            substitute_source_org_id (int): . [optional]
            limit (int): Numerical limit of results returned. [optional]
            offset (int): Offset of results returned. [optional] if omitted the server will use the default value of 0
            include_deleted (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            [VacancyDetailResponse]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['org_id'] = \
            org_id
        kwargs['from_date'] = \
            from_date
        kwargs['to_date'] = \
            to_date
        return self.get_vacancy_details_endpoint.call_with_http_info(**kwargs)

