"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from redrover_api.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from redrover_api.exceptions import ApiAttributeError


def lazy_import():
    from redrover_api.model.accounting_code_allocation_request import AccountingCodeAllocationRequest
    from redrover_api.model.int32_locator_request import Int32LocatorRequest
    from redrover_api.model.position_schedule_custom_variant_request import PositionScheduleCustomVariantRequest
    globals()['AccountingCodeAllocationRequest'] = AccountingCodeAllocationRequest
    globals()['Int32LocatorRequest'] = Int32LocatorRequest
    globals()['PositionScheduleCustomVariantRequest'] = PositionScheduleCustomVariantRequest


class PositionScheduleItemRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'location': (Int32LocatorRequest,),  # noqa: E501
            'bell_schedule': (Int32LocatorRequest,),  # noqa: E501
            'accounting_code_allocations': ([AccountingCodeAllocationRequest], none_type,),  # noqa: E501
            'job': (Int32LocatorRequest,),  # noqa: E501
            'start_period': (Int32LocatorRequest,),  # noqa: E501
            'end_period': (Int32LocatorRequest,),  # noqa: E501
            'periods_not_needing_replacement': ([Int32LocatorRequest], none_type,),  # noqa: E501
            'standard_custom_schedule_variant': (PositionScheduleCustomVariantRequest,),  # noqa: E501
            'additional_custom_schedule_variants': ([PositionScheduleCustomVariantRequest], none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'location': 'location',  # noqa: E501
        'bell_schedule': 'bellSchedule',  # noqa: E501
        'accounting_code_allocations': 'accountingCodeAllocations',  # noqa: E501
        'job': 'job',  # noqa: E501
        'start_period': 'startPeriod',  # noqa: E501
        'end_period': 'endPeriod',  # noqa: E501
        'periods_not_needing_replacement': 'periodsNotNeedingReplacement',  # noqa: E501
        'standard_custom_schedule_variant': 'standardCustomScheduleVariant',  # noqa: E501
        'additional_custom_schedule_variants': 'additionalCustomScheduleVariants',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, location, bell_schedule, *args, **kwargs):  # noqa: E501
        """PositionScheduleItemRequest - a model defined in OpenAPI

        Args:
            location (Int32LocatorRequest):
            bell_schedule (Int32LocatorRequest):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            accounting_code_allocations ([AccountingCodeAllocationRequest], none_type): Accounting Code allocations. [optional]  # noqa: E501
            job (Int32LocatorRequest): [optional]  # noqa: E501
            start_period (Int32LocatorRequest): [optional]  # noqa: E501
            end_period (Int32LocatorRequest): [optional]  # noqa: E501
            periods_not_needing_replacement ([Int32LocatorRequest], none_type): The Periods that do not need replacement. [optional]  # noqa: E501
            standard_custom_schedule_variant (PositionScheduleCustomVariantRequest): [optional]  # noqa: E501
            additional_custom_schedule_variants ([PositionScheduleCustomVariantRequest], none_type): Additional custom schedule variant. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.location = location
        self.bell_schedule = bell_schedule
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, location, bell_schedule, *args, **kwargs):  # noqa: E501
        """PositionScheduleItemRequest - a model defined in OpenAPI

        Args:
            location (Int32LocatorRequest):
            bell_schedule (Int32LocatorRequest):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            accounting_code_allocations ([AccountingCodeAllocationRequest], none_type): Accounting Code allocations. [optional]  # noqa: E501
            job (Int32LocatorRequest): [optional]  # noqa: E501
            start_period (Int32LocatorRequest): [optional]  # noqa: E501
            end_period (Int32LocatorRequest): [optional]  # noqa: E501
            periods_not_needing_replacement ([Int32LocatorRequest], none_type): The Periods that do not need replacement. [optional]  # noqa: E501
            standard_custom_schedule_variant (PositionScheduleCustomVariantRequest): [optional]  # noqa: E501
            additional_custom_schedule_variants ([PositionScheduleCustomVariantRequest], none_type): Additional custom schedule variant. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.location = location
        self.bell_schedule = bell_schedule
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
